#loading data
import json

print("Usage - Enter file names one by one. Once finished, just hit ENTER!\n")
data = list()
while True:
    filename = input("Enter file name: ")
    if len(filename) == 0:
      break
    try:
        file = open(filename, encoding="UTF-8")
        filedata = json.load(file)
        data.append(filedata)
    except:
        print(f"Failed to load file '{filename}'")

while True:
    timespan = input("Do you want to count statistics based on past [YEAR] or past [MONTH]? ")
    if timespan == "YEAR" or timespan == "MONTH":
        break

#between these days
first_listen = None
last_listen = None
for list in data:
    for song in list:
        if first_listen == None and last_listen == None:
            first_listen = song["endTime"]
            last_listen = song["endTime"]
        if song["endTime"].split()[0] < first_listen:
            early_d = song["endTime"]
        if song["endTime"].split()[0] > last_listen:
            last_listen = song["endTime"]

#past month
if timespan == "MONTH":
    lastdate = last_listen.split("-")
    if lastdate[1] == "01":
        lastmonth = 12
    else:
        lastmonth = int(lastdate[1]) - 1
        if lastmonth < 10:
            lastmonth = ("0" + str(lastmonth))
        else:
            lastmonth = int(lastmonth)
    pastmonth = lastdate[0] + "-" + lastmonth + "-" + lastdate[2]
    print(f"\ndata are being retrieved from days between {pastmonth} and {last_listen}...\n")
else:
    print(f"\ndata are being retrieved from days between {first_listen} and {last_listen}...\n")

#hourly listening
hourxtimes = dict()
for list in data:        
    for song in list:
        if 'endTime' not in song:
            continue
        if timespan == "MONTH":
            if song["endTime"] < pastmonth:
                continue
        date = song['endTime']
        time = date.split()[1]
        hour = time.split(":")[0]
        hourxtimes[hour] = hourxtimes.get(hour, 0) + 1
totalsongs = 0
hourxtimes = sorted(hourxtimes.items())
for tuple in hourxtimes:
    # print(f"    listened to {tuple[1]} songs at {tuple[0]} o'clock")
    totalsongs += tuple[1]
    
print(f"\nlistened to {totalsongs} tracks in total")

#total minutes listening
total_ms = 0
for list in data:
    for song in list:
        if timespan == "MONTH":
            if song["endTime"] < pastmonth:
                continue
        miliseconds = song["msPlayed"]
        total_ms += miliseconds    

seconds = int(total_ms/1000)
minutes = int(seconds/60)
hours = int(minutes/60)
res_seconds = seconds%60
print(f"listened {hours} hours, which equals to {minutes} minutes or {seconds} seconds in total in that time")

# most listened artists
artListened = dict()
timListened = []
for list in data:
    for song in list:
        if timespan == "MONTH":
            if song["endTime"] < pastmonth:
                continue
        artist = song["artistName"]
        time2 = song["msPlayed"]
        artListened[artist] = artListened.get(artist, 0) + int(time2/1000/60)
for k, v in artListened.items():
    timListened.append((v, k))
timListened.sort(reverse=True)
overallline = []
for tuple in timListened:
    eachline = f"listened for '{tuple[0]} minutes' to 'artist {tuple[1]}'\n"
    overallline.append(eachline)

#save to file // artists
if timespan == "MONTH":
    fh = open("Artists_Listen_Time_Month.txt", "w", encoding="UTF-8")
    fh.write("TOP ARTISTS FROM THE PAST MONTH\n")
    for line in overallline:
        fh.write(line)
    fh.close()
    print("Artists' listen time saved to file 'Artists_Listen_Time_Month.txt'")
if timespan == "YEAR":
    fh = open("Artists_Listen_Time_YEAR.txt", "w", encoding="UTF-8")
    fh.write("TOP ARTISTS FROM THE PAST YEAR\n")
    for line in overallline:
        fh.write(line)
    fh.close()
    print("Artists' listen time saved to file 'Artists_Listen_Time_Year.txt'")

#most listened songs
songListened = dict()
songartListen = dict()
stimeListened = []
for list in data:
    for song in list:
        if timespan == "MONTH":
            if song["endTime"] < pastmonth:
                continue        
        name = song[str("trackName")]
        time3 = song["msPlayed"]
        artist3 = song["artistName"]
        songartListen[name] = songartListen.get(name, artist3)
        songListened[name] = songListened.get(name, 0) + int(time3/1000/60)
for k, v in songListened.items():
    a = songartListen[k]
    stimeListened.append((v, k, a))
stimeListened.sort(reverse=True)
overallline2 = []
for tuple in stimeListened:
    eachline = f"listened for '{tuple[0]} minutes' to 'song {tuple[1]}' by {tuple[2]}\n"
    overallline2.append(eachline)

#save to file // songs
if timespan == "MONTH":
    fh2 = open("Songs_Listen_Time_Month.txt", "w", encoding="UTF-8")
    fh2.write("TOP SONGS FROM THE PAST MONTH\n")
    for line in overallline2:
        fh2.write(line)
    fh.close()
    print("Songs' listen time saved to file 'Songs_Listen_Time_Month.txt'")

if timespan == "YEAR":
    fh2 = open("Songs_Listen_Time_Year.txt", "w", encoding="UTF-8")
    fh2.write("TOP SONGS FROM THE PAST YEAR\n")
    for line in overallline2:
        fh2.write(line)
    fh.close()
    print("Songs' listen time saved to file 'Songs_Listen_Time_Year.txt'")

